/*
 * ** Paging Module (Bean with DBConnectionManager) **
 *  : ̼
 * ۳ : 2002 2 2
 *  : 0.2
 * hsboy@orgio.net
 * http://aboutjsp.com
 */


package about;

import java.sql.*;
import DBConnectionManager;

public class Paging{

	private int currentPage=1;  //  
	private int pgroup; //  ׷
	private int totalRow;  // ü ڵ
	private int rows;  //   ڵ
	private int lastPage; //  ȣ (ü )
	private int totalGroup;  // ü ׷
	private DBConnectionManager dbm;
	private Connection con;
	private Statement st;
	private String sql;
	private String db;


	// ׷ ¡ (pgroup)
	public ResultSet init(String db,String table,String query,int page,int pgroup) throws SQLException{
		// db : DBConnectionManager db.properties  ̸
		// table :  ̺ ̸
		// query :   (select * from table) ̺ ̸  ̺ ̸ ġ ؾ Ѵ.
		// rows :  Ÿ ټ
		this.db=db;
		this.rows=10;
		dbm=DBConnectionManager.getInstance();
		con=dbm.getConnection(db);
		this.st=con.createStatement();
	

		// ü ڵ  ϱ
		// Ǿ ϴ κ
		sql="select count(*) from "+table;
		ResultSet rs=st.executeQuery(sql);
		rs.next();
		this.totalRow=rs.getInt(1);
		
		// ü   ϱ
		this.lastPage=this.totalRow / this.rows + 1;
		if( (this.totalRow % this.rows) == 0 ) {
			this.lastPage=this.lastPage -1 ;
		}
		
		// ü ׷ ϱ
		this.totalGroup=this.totalRow / (this.rows * 10) + 1 ;
		if ((this.totalRow % (this.rows * 10)) == 0 ){
			this.totalGroup -= 1;
		}
		
		rs=this.st.executeQuery(query);

		this.currentPage=page; //   
		this.pgroup=pgroup; //   ׷켳

		if(this.currentPage==1&&this.pgroup==1) {
		} else {
			int tmp=(this.currentPage - 1) * rows + ((this.pgroup - 1) * rows * 10);
			rs.absolute(tmp);
		}

		return rs;
	}


	// ¡ (page) 
	public ResultSet init(String db,String table,String query,int page) throws SQLException{
		// db : DBConnectionManager db.properties  ̸
		// table :  ̺ ̸
		// query :   (select * from table) ̺ ̸  ̺ ̸ ġ ؾ Ѵ.
		// rows :  Ÿ ټ
		this.db=db;
		this.rows=10;
		dbm=DBConnectionManager.getInstance();
		con=dbm.getConnection(db);
		this.st=con.createStatement();
	
		// ü ڵ  ϱ
		// Ǿ ϴ κ
		sql="select count(*) from "+table;
		ResultSet rs=st.executeQuery(sql);
		rs.next();
		this.totalRow=rs.getInt(1);
		
		// ü   ϱ
		this.lastPage=this.totalRow / this.rows + 1; 
		if( (this.totalRow % this.rows) == 0 ) {
			this.lastPage=this.lastPage - 1 ;
		}

		rs=this.st.executeQuery(query);
		
		//   ϱ
		this.currentPage=page; 
		if(this.currentPage==1) {
		} else {
			int tmp=(this.currentPage-1) * rows;
			rs.absolute(tmp);
		}

		return rs;
	}


	//   ȣ 
	public int getCurrentPage(){
		return this.currentPage;
	}

	// ü  ȣ ( ȣ=ü )
	public int getLastPage(){
		return this.lastPage;
	}

	//  ׷ 
	public int getGroup(){
 		return this.pgroup;
	}

	// ü ڵ尹 
	public int getTotalRow(){
		return this.totalRow;
	}

	// ü ׷ 
	public int getTotalGroup(){
		return this.totalGroup;
	}

	//    
	public int getRows(){
		return this.rows;
	}


	//  ׷ ˻
	public boolean isLastGroup() throws SQLException{
		if(this.totalGroup == getGroup()) return true;
		return false;
	}


	
	// DB ؼ  ִ κ.   ݵ ؾ ش ޼ҵ̴.
	public void close() throws SQLException{
		this.st.close();
		this.dbm.freeConnection(db,con);
	}
}